## lomiri-indicator-network 1.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(lomiri-indicator-network VERSION 1.0.2 LANGUAGES C CXX)

string(TOLOWER "${CMAKE_BUILD_TYPE}" build_type_lower)

if("${build_type_lower}" STREQUAL debug)
  set(TRACE_DEFAULT TRUE)
else()
  set(TRACE_DEFAULT FALSE)
endif()

option(trace_messages "Print debug trace messages." ${TRACE_DEFAULT})
option(REMOTE_BUILD "Remote build (skip docs, translations, tests)." FALSE)
option(ENABLE_TESTS "Enable tests" TRUE)
option(ENABLE_COVERAGE "Generate Coverage Reports" TRUE)
option(ENABLE_UBUNTU_COMPAT "Enable Ubuntu.Connectivity QML compatibility layer" OFF)
option(USE_SYSTEMD "Install systemd services" ON)

if(${trace_messages})
  add_definitions(-DINDICATOR_NETWORK_TRACE_MESSAGES)
endif()

add_definitions(
  -DQT_NO_KEYWORDS=1
)

find_package(PkgConfig REQUIRED)
include(GNUInstallDirs)
find_package(GSettings)

set(PROJECT_VERSION "16.10.0")
set(PACKAGE ${CMAKE_PROJECT_NAME})
set(GETTEXT_PACKAGE lomiri-indicator-network)
add_definitions (
    -DGETTEXT_PACKAGE="${GETTEXT_PACKAGE}"
    -DLOCALE_DIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
)

set(DATA_DIR "${CMAKE_SOURCE_DIR}/data")

set(GLIB_REQUIRED_VERSION 2.26)

pkg_check_modules(
  GLIB REQUIRED
  glib-2.0>=${GLIB_REQUIRED_VERSION}
  gio-2.0>=${GLIB_REQUIRED_VERSION}
)
include_directories(${GLIB_INCLUDE_DIRS})

pkg_check_modules(
  LOMIRI_API REQUIRED
  liblomiri-api
)
include_directories(${LOMIRI_API_INCLUDE_DIRS})

set(OFONO_REQUIRED_VERSION 1.12)
pkg_check_modules(
  OFONO REQUIRED
  ofono>=${OFONO_REQUIRED_VERSION}
)
include_directories(${OFONO_INCLUDE_DIRS})

pkg_check_modules(
  LIBSECRET REQUIRED
  libsecret-1
)
include_directories(${LIBSECRET_INCLUDE_DIRS})

find_package(Qt5Core REQUIRED)
include_directories(${Qt5Core_INCLUDE_DIRS})

find_package(Qt5DBus COMPONENTS Qt5DBusMacros REQUIRED)
include_directories(${Qt5DBus_INCLUDE_DIRS})

pkg_check_modules(NM REQUIRED libnm REQUIRED)
include_directories(${NM_INCLUDE_DIRS})

pkg_check_modules(URL_DISPATCHER REQUIRED lomiri-url-dispatcher)
include_directories(${URL_DISPATCHER_INCLUDE_DIRS})

if(USE_SYSTEMD)
  pkg_check_modules(SYSTEMD systemd REQUIRED)
endif()

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

include_directories(${CMAKE_BINARY_DIR})

set(COMMON_FLAGS "-Wall -Wextra -Wpedantic -fno-permissive -fPIC -fvisibility=hidden -pthread")

set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 14)
if(CMAKE_COMPILER_IS_GNUCC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${COMMON_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${COMMON_FLAGS}")
endif()

set(CONNECTIVITY_QT_VERSION_MAJOR 1)
set(CONNECTIVITY_QT_VERSION_MINOR 0)
set(CONNECTIVITY_QT_LIB_TARGET lomiri-connectivity-qt${CONNECTIVITY_QT_VERSION_MAJOR})

add_subdirectory(data)
add_subdirectory(src)

if(NOT REMOTE_BUILD)

add_subdirectory(po)
add_subdirectory(doc)

if(ENABLE_TESTS)
enable_testing()
add_subdirectory(tests)

ADD_CUSTOM_TARGET(
        check
        ${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure
)

if(ENABLE_COVERAGE)
  find_package(CoverageReport)
  enable_coverage_report(
    TARGETS
      lomiri-indicator-network-service
      menumodel_cpp
      notify_cpp
      qdbus-stubs
      i-n-sniffer
      url_dispatcher_cpp
    TESTS
      unit-tests
      integration-tests
      secret-agent-test-bin
    FILTER
      ${CMAKE_SOURCE_DIR}/tests/*
      ${CMAKE_BINARY_DIR}/*
  )
endif()

endif()

endif()

add_subdirectory(scripts)

=== data/CMakeLists.txt ===

###########################
# Lomiri-indicator-network service
###########################

set(
  INDICATOR_DIR
  "${CMAKE_INSTALL_DATADIR}/unity/indicators"
  CACHE FILEPATH "Indicator directory"
)

install(
  FILES "com.lomiri.indicator.network"
  DESTINATION "${INDICATOR_DIR}"
)

pkg_get_variable(DBUS_SESSION_BUS_SERVICES_DIR dbus-1 session_bus_services_dir)
install(
  FILES "dbus-service_com.lomiri.connectivity1.service"
  RENAME "com.lomiri.connectivity1.service"
  DESTINATION "${DBUS_SESSION_BUS_SERVICES_DIR}"
)

###########################
# Lomiri-indicator-network systemd jobs
###########################

if (USE_SYSTEMD)
  pkg_get_variable(SYSTEMD_USER_DIR systemd systemduserunitdir)
  message (STATUS "${SYSTEMD_USER_DIR} is the systemd user unit file install dir")

  set(
    AGENT_SERVICE
    "${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri-indicator-network/lomiri-indicator-network-secret-agent"
  )

  configure_file (
    lomiri-indicator-network-secret-agent.service.in
    lomiri-indicator-network-secret-agent.service
    @ONLY
  )

  set(
    NETWORK_SERVICE
    "${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri-indicator-network/lomiri-indicator-network-service"
  )

  configure_file (
    lomiri-indicator-network.service.in
    lomiri-indicator-network.service
    @ONLY
  )

  install (
    FILES "${CMAKE_CURRENT_BINARY_DIR}/lomiri-indicator-network-secret-agent.service"
    DESTINATION ${SYSTEMD_USER_DIR}
  )

  install (
    FILES "${CMAKE_CURRENT_BINARY_DIR}/lomiri-indicator-network.service"
    DESTINATION ${SYSTEMD_USER_DIR}
  )
endif()

###########################
# GSettings
###########################

add_schema ("com.lomiri.indicator.network.gschema.xml")

###########################
# XDG Autostart File
###########################

# where to install
set (XDG_AUTOSTART_DIR "${CMAKE_INSTALL_SYSCONFDIR}/xdg/autostart")
message (STATUS "${XDG_AUTOSTART_DIR} is the DBus Service File install dir")

set (XDG_AUTOSTART_NAME "${CMAKE_PROJECT_NAME}.desktop")
set (XDG_AUTOSTART_FILE "${CMAKE_CURRENT_BINARY_DIR}/${XDG_AUTOSTART_NAME}")
set (XDG_AUTOSTART_FILE_IN "${CMAKE_CURRENT_SOURCE_DIR}/${XDG_AUTOSTART_NAME}.in")

# build it
set (pkglibexecdir "${CMAKE_INSTALL_FULL_PKGLIBEXECDIR}")
configure_file ("${XDG_AUTOSTART_FILE_IN}" "${XDG_AUTOSTART_FILE}")

# install it
install (FILES "${XDG_AUTOSTART_FILE}"
         DESTINATION "${XDG_AUTOSTART_DIR}")

=== doc/CMakeLists.txt ===
set(INSTALL_DOCDIR ${CMAKE_INSTALL_DOCDIR})

option(BUILD_DOC "Build documentation by default" TRUE)
option(PRIVATE_DOCS "Build private documentation" FALSE)

add_subdirectory(qt)

install(
    DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/dbus/
    DESTINATION ${INSTALL_DOCDIR}/dbus/
)

=== po/CMakeLists.txt ===
include(FindGettext)

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if("${GETTEXT_XGETTEXT_EXECUTABLE}" STREQUAL "GETTEXT_XGETTEXT_EXECUTABLE-NOTFOUND")
    message(FATAL_ERROR "Could not find xgettext")
endif()

set(DOMAIN ${PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
               ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY)

add_custom_target(${POT_FILE} ALL
                  COMMENT "Generating translation template"
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          -D ${CMAKE_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_BINARY_DIR}
                          --from-code=UTF-8
                          --c++
                          --qt
                          --add-comments=TRANSLATORS
                          --keyword=_ --keyword=tr --keyword=tr:1,2
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES)

foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY)
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
                         LANGUAGES ${LANGS})

=== src/indicator/agent/CMakeLists.txt ===

set(
	INDICATOR_SECRET_AGENT_SOURCES
	SecretAgent.cpp
	SecretAgentAdaptor.cpp
	SecretRequest.cpp
	PasswordMenu.cpp
)

qt5_add_dbus_adaptor(
	INDICATOR_SECRET_AGENT_SOURCES
	"${DATA_DIR}/nm-secret-agent.xml"
	SecretAgentInclude.h
	SecretAgent
	SecretAgentAdaptor
)

qt5_add_dbus_interface(
	INDICATOR_SECRET_AGENT_SOURCES
	"${DATA_DIR}/nm-agent-manager.xml"
	AgentManagerInterface
)

set_source_files_properties(
	"${DATA_DIR}/org.freedesktop.Notifications.xml"
	PROPERTIES
	INCLUDE "DBusTypes.h"
)

qt5_add_dbus_interface(
	INDICATOR_SECRET_AGENT_SOURCES
	"${DATA_DIR}/org.freedesktop.Notifications.xml"
	NotificationsInterface
)

add_library(
	indicator-secret-agent
	STATIC
	${INDICATOR_SECRET_AGENT_SOURCES}
)

target_link_libraries(
	indicator-secret-agent
	Qt5::Core
	Qt5::DBus
)

target_link_libraries(
	indicator-secret-agent
	${GIO_LIBRARIES}
)

add_executable(
	indicator-secret-agent-bin
	main.cpp
)

set_target_properties(
	indicator-secret-agent-bin
	PROPERTIES
	OUTPUT_NAME indicator-secret-agent
)

target_link_libraries(
	indicator-secret-agent-bin
	Qt5::Core
)

target_link_libraries(
	indicator-secret-agent-bin
	indicator-secret-agent
)

install(
	TARGETS indicator-secret-agent-bin
	RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}"
)

=== debian/changelog ===
lomiri-indicator-network (1.0.2-4build4) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 12 Apr 2024 05:39:22 +0000

lomiri-indicator-network (1.0.2-4build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:58:27 +0000

lomiri-indicator-network (1.0.2-4build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:45:11 +0000

lomiri-indicator-network (1.0.2-4build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:08:28 +0000

lomiri-indicator-network (1.0.2-4) unstable; urgency=medium

  * debian/rules:
    + Stop using pkgkde_symbolshelper tool.
  * debian/control:
    + Drop from B-D: pkg-kde-tools.
  * debian/liblomiri-connectivity-qt1-1.symbols:
    + Drop file. Having caused more woes than happiness, esp. in relation to
      cross-distro maintenance (Debian/Ubuntu).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 03 Mar 2024 00:20:46 +0100

lomiri-indicator-network (1.0.2-3) unstable; urgency=medium

  * debian/control:
    + Promote from S: to D: (lomiri-indicator-network): urfkill. Otherwise, the
      flightmode button will not work.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 29 Feb 2024 17:23:22 +0100

lomiri-indicator-network (1.0.2-2) unstable; urgency=medium

  * debian/copyright:
    + Update auto-generated copyright.in file.
  * debian/rules:
    + Revert: Drop removal of empty dir, no longer in upstream"
    + Adjust path when removing empty dir after build.
  * debian/control:
    + In B-D:, switch from systemd to systemd-dev. (Closes: #1060514).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 02 Feb 2024 13:36:45 +0100

lomiri-indicator-network (1.0.2-1) unstable; urgency=medium

  [ Marius Gripsgard ]
  * New upstream release
  * debian/copyright: Use my debian email
  * debian/copyright: Refresh copyright to match upstream
  * debian/symbols: Add symbol to match new release
  * debian/l-c-doc: Adjust new folder name for docs
  * debian/install: Add dbus service file from new release
  * debian/rules: Drop strict symbols
  * debian/rules: Drop removal of empty dir, no longer in upstream

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository.
  * Remove unnecessary get-orig-source-target.

  [ Mike Gabriel ]
  * Revert "Remove unnecessary get-orig-source-target."

 -- Marius Gripsgard <mariogrip@debian.org>  Fri, 02 Feb 2024 02:59:17 +0100

=== debian/control ===
Source: lomiri-indicator-network
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <mariogrip@debian.org>,
Build-Depends: cmake,
               cmake-extras,
               dbus,
               debhelper-compat (= 13),
               doxygen,
               googletest (>= 1.10),
               libgtest-dev,
               graphviz,
               intltool,
               libglib2.0-dev,
               libgmenuharness-dev (>= 0.1.1),
               libqofono-dev,
               libqofono-qt5-0,
               libqtdbusmock1-dev,
               libqtdbustest1-dev,
               libsecret-1-dev,
               liblomiri-url-dispatcher-dev,
               liblomiri-api-dev,
               libnm-dev,
               ofono-dev,
               pkg-config,
               python3-all:native,
               python3-dbusmock (>= 0.28.4),
               qtbase5-dev,
               qtbase5-dev-tools,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qttools5-dev-tools,
               valgrind-if-available,
               systemd-dev [linux-any],
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-indicator-network.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-indicator-network
Homepage: https://gitlab.com/ubports/development/core/lomiri-indicator-network

Package: lomiri-indicator-network
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ayatana-indicator-common,
         network-manager,
         network-manager-openvpn,
         network-manager-pptp,
         suru-icon-theme,
         urfkill,
Suggests: ofono,
Conflicts: chewie,
           indicators-client-plugin-network,
           indicator-network-autopilot,
           indicator-network-tools,
Replaces: indicator-network-autopilot,
          indicator-network-tools,
Provides: indicator-network-autopilot,
          indicator-network-tools,
Description: Systems settings menu service - Network indicator
 The Lomiri-indicator-network service is responsible for exporting the system
 settings menu through D-Bus.
 .
 This indicator is basically an Ayatana system indicator, but it has been
 specifically been designed for the Lomiri Operating Environment. If you
 try using it with another desktop environment, note that you are on
 unexplored territory.

Package: liblomiri-connectivity-qt1-1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Breaks: liblomiri-connectivity-qt1,
Replaces: liblomiri-connectivity-qt1,
Recommends: lomiri-indicator-network (>= ${source:Version}),
Description: Lomiri Connectivity Qt API
 Lomiri Connectivity API - Qt bindings.
 .
 This package contains the share library.

Package: liblomiri-connectivity-qt1-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-connectivity-qt1-1 (= ${binary:Version}),
         qtbase5-dev
Suggests: connectivity-doc,
Description: Lomiri Connectivity Qt API - development files
 Lomiri Connectivity API - Qt bindings.
 .
 This package contains development files to develop against the Qt
 library.

Package: qml-module-lomiri-connectivity
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-connectivity-qt1-1 (= ${binary:Version}),
Description: Lomiri Connectivity API QML Components
 Lomiri Connectivity API - QML bindings.
 .
 This package contains the qtdeclarative bindings for Lomiri connectivity
 API.

Package: lomiri-connectivity-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri Connectivity API - documentation
 Lomiri Connectivity API.
 .
 This package contains developer documentation.

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/lomiri-indicator-network/tags .*/lomiri-indicator-network-(\d\S+)\.tar\.gz

## lomiri-indicator-network 1.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.13)
 
-project(lomiri-indicator-network VERSION 1.0.2 LANGUAGES C CXX)
+project(lomiri-indicator-network VERSION 1.1.0 LANGUAGES C CXX)
 
 string(TOLOWER "${CMAKE_BUILD_TYPE}" build_type_lower)
 
@@ -14,11 +14,16 @@
 option(REMOTE_BUILD "Remote build (skip docs, translations, tests)." FALSE)
 option(ENABLE_TESTS "Enable tests" TRUE)
 option(ENABLE_COVERAGE "Generate Coverage Reports" TRUE)
+option(ENABLE_MECHANICD "Enable integration with Mechanicd" OFF)
 option(ENABLE_UBUNTU_COMPAT "Enable Ubuntu.Connectivity QML compatibility layer" OFF)
 option(USE_SYSTEMD "Install systemd services" ON)
 
 if(${trace_messages})
   add_definitions(-DINDICATOR_NETWORK_TRACE_MESSAGES)
+endif()
+
+if(ENABLE_MECHANICD)
+  add_definitions(-DENABLE_MECHANICD)
 endif()
 
 add_definitions(

=== tests/integration/CMakeLists.txt ===

add_definitions(-DNETWORK_SERVICE_BIN="${CMAKE_BINARY_DIR}/src/indicator/lomiri-indicator-network-service")

include_directories(
    "${CMAKE_SOURCE_DIR}/src/connectivity-api/connectivity-qt"
    "${CMAKE_SOURCE_DIR}/src/indicator/nmofono/connection"
    "${CMAKE_SOURCE_DIR}/src/indicator/nmofono/vpn"
    "${CMAKE_SOURCE_DIR}/src/indicator"
    "${CMAKE_SOURCE_DIR}/src/qdbus-stubs"
    "${CMAKE_SOURCE_DIR}/src"
    "${CMAKE_BINARY_DIR}/src/qdbus-stubs"

    # For GObjectDeleter
    "${CMAKE_SOURCE_DIR}/src/menumodel-cpp"
)

set(
    INTEGRATION_TESTS_SRC
    indicator-network-test-base.cpp
    test-indicator.cpp
    test-indicator-vpn.cpp
    test-connectivity-api.cpp
    test-connectivity-api-modem.cpp
    test-connectivity-api-sim.cpp
    test-connectivity-api-vpn.cpp
)

add_executable(
    integration-tests
    ${INTEGRATION_TESTS_SRC}
)

target_link_libraries(
    integration-tests
    Qt5::Core
    Qt5::DBus
    Qt5::Test
)

target_link_libraries(
    integration-tests
    test-utils
    lomiri-indicator-network-service-static
    ${CONNECTIVITY_QT_LIB_TARGET}
    ${TEST_DEPENDENCIES_LDFLAGS}
    ${GTEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
    ${GLIB_LDFLAGS}
)

file(COPY sample.ovpn DESTINATION ${CMAKE_BINARY_DIR}/tests/integration)

add_test(
    integration-tests
    integration-tests
)

=== tests/unit/CMakeLists.txt ===

include_directories(
    "${CMAKE_SOURCE_DIR}/src"
    "${CMAKE_SOURCE_DIR}/src/indicator"
    "${CMAKE_SOURCE_DIR}/src/qdbus-stubs"
    "${CMAKE_BINARY_DIR}/src/qdbus-stubs"
    ${CMAKE_CURRENT_BINARY_DIR}
)

###########################
# Secret agent mini binary
###########################

add_definitions(
    -DSECRET_AGENT_BIN="${CMAKE_CURRENT_BINARY_DIR}/secret-agent-test-bin"
)

add_executable(
    secret-agent-test-bin
    secret-agent/secret-agent-main.cpp
)

target_link_libraries(
    secret-agent-test-bin
    Qt5::Core
)

target_link_libraries(
    secret-agent-test-bin
    agent-static
)

###################
# Unit test binary
###################

set(
    UNIT_TESTS_SRC

    indicator/menuitems/test-access-point-item.cpp
    indicator/menuitems/test-switch-item.cpp

    menumodel-cpp/test-menu-exporter.cpp

    secret-agent/test-secret-agent.cpp
)

set_source_files_properties(
    "${DATA_DIR}/nm-secret-agent.xml"
    PROPERTIES
    INCLUDE "dbus-types.h"
)

qt5_add_dbus_interface(
    UNIT_TESTS_SRC
    "${DATA_DIR}/nm-secret-agent.xml"
    SecretAgentInterface
)

add_executable(
    unit-tests
    ${UNIT_TESTS_SRC}
)

target_link_libraries(
    unit-tests
    Qt5::Core
    Qt5::DBus
    Qt5::Test
)

target_link_libraries(
    unit-tests
    test-utils
    lomiri-indicator-network-service-static
    ${TEST_DEPENDENCIES_LDFLAGS}
    ${GLIB_LDFLAGS}
    ${GTEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
)

add_test(
    unit-tests
    unit-tests
)

=== doc/qt/cpp/CMakeLists.txt ===

add_subdirectory(examples)

find_package(DoxygenBuilder REQUIRED)

add_doxygen(
    qtdoc
    PROJECT_NAME
        "lomiri-connectivity-api"
    INPUT
        "${CMAKE_SOURCE_DIR}/src/connectivity-api/connectivity-qt"
        "${CMAKE_CURRENT_SOURCE_DIR}/pages"
    EXAMPLE_PATH
        "${CMAKE_SOURCE_DIR}/doc/qt/cpp/examples/"
    STRIP_FROM_PATH
        "${CMAKE_SOURCE_DIR}/src/connectivity-api/connectivity-qt"
    STRIP_FROM_INC_PATH
        "${CMAKE_SOURCE_DIR}/src/connectivity-api/connectivity-qt"
    EXCLUDE_PATTERNS
        */internal/*
    EXCLUDE_SYMBOLS
	*::internal*
        *::Priv
    INSTALL
        "${INSTALL_DOCDIR}/cpp"
    XML
    ALL
)

=== src/connectivity-api/connectivity-qml/CMakeLists.txt ===
 
find_package(QmlPlugins)

find_package(Qt5Quick REQUIRED)

include_directories(
  "${CMAKE_SOURCE_DIR}/src/connectivity-api/connectivity-qt"
)

set(CONNECTIVITY_QML_SRC
    plugin.cpp
)

add_library(connectivity-qml SHARED
  ${CONNECTIVITY_QML_SRC}
)
target_link_libraries(
  connectivity-qml
  ${CONNECTIVITY_QT_LIB_TARGET}
)


target_link_libraries(connectivity-qml
  Qt5::Qml
)


add_qmlplugin(
  Lomiri.Connectivity
  1.0
  Lomiri/Connectivity
  TARGET_PREFIX Connectivity
  TARGETS connectivity-qml
)

=== debian/changelog ===
lomiri-indicator-network (1.1.0-1build1) plucky; urgency=medium

  * Rebuild against new ppp 2.5.2-1+1.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 26 Feb 2025 15:28:59 +0100

lomiri-indicator-network (1.1.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 0001_lomiri-indicators-target.patch. Applied upstream.
  * debian/control:
    + Require suru-icon-theme >= 2024.10.13~.
    + In B-D, switch from pkg-config to pkgconf.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 07 Jan 2025 16:54:45 +0100

lomiri-indicator-network (1.0.2-7) unstable; urgency=medium

  * debian/control:
    + Add to D (liblomiri-connectivity-qt1-dev): liblomiri-api-dev.
    + Bump Standards-Version to 4.7.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 16 Aug 2024 19:41:59 +0200

lomiri-indicator-network (1.0.2-6) unstable; urgency=medium

  [ Guido Berhoerster ]
  * debian/control:
    + Revert "Bump B-D to libglib2.0-dev (>= 2.80.2-2~) due to a memory problem
      between 2.80.0 and 2.80.2-1)." The issue is now gone from Debian and
      the hard-wired B-D blocks backporting this src:pkg to Ubuntu 24.04 LTS.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 14 Aug 2024 10:51:17 +0200

lomiri-indicator-network (1.0.2-5) unstable; urgency=medium

  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/patches:
    + Add 0001_lomiri-indicators-target.patch. Launch with lomiri-
      indicators.target only now, not with ayatana-indicators.target anymore.
  * debian/control:
    + Bump B-D to libglib2.0-dev (>= 2.80.2-2~) due to a memory problem between
      2.80.0 and 2.80.2-1). (Closes: #1071328).
  * debian/copyright:
    + Update copyright attribution for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 26 May 2024 15:00:58 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: lomiri-indicator-network
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
  Marius Gripsgard <mariogrip@debian.org>,
@@ -26,7 +25,7 @@
                liblomiri-api-dev,
                libnm-dev,
                ofono-dev,
-               pkg-config,
+               pkgconf,
                python3-all:native,
                python3-dbusmock (>= 0.28.4),
                qtbase5-dev,
@@ -36,7 +35,7 @@
                qttools5-dev-tools,
                valgrind-if-available,
                systemd-dev [linux-any],
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-indicator-network.git
 Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-indicator-network
@@ -51,7 +50,7 @@
          network-manager,
          network-manager-openvpn,
          network-manager-pptp,
-         suru-icon-theme,
+         suru-icon-theme (>= 2024.10.13~),
          urfkill,
 Suggests: ofono,
 Conflicts: chewie,
@@ -94,6 +93,7 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          liblomiri-connectivity-qt1-1 (= ${binary:Version}),
+         liblomiri-api-dev,
          qtbase5-dev
 Suggests: connectivity-doc,
 Description: Lomiri Connectivity Qt API - development files

## lomiri-indicator-network 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.13)
 
-project(lomiri-indicator-network VERSION 1.1.0 LANGUAGES C CXX)
+project(lomiri-indicator-network VERSION 1.1.1 LANGUAGES C CXX)
 
 string(TOLOWER "${CMAKE_BUILD_TYPE}" build_type_lower)

=== src/agent/CMakeLists.txt ===

include_directories("${CMAKE_SOURCE_DIR}/src")
include_directories("${CMAKE_BINARY_DIR}/src/qdbus-stubs")
include_directories("${CMAKE_SOURCE_DIR}/src/qdbus-stubs")

set(AGENT_SOURCES
  CredentialStore.cpp
  KeyringCredentialStore.cpp
  SecretAgent.cpp
  SecretRequest.cpp
  PasswordMenu.cpp
)

qt5_add_dbus_adaptor(
    AGENT_SOURCES
    "${DATA_DIR}/nm-secret-agent.xml"
    "agent/SecretAgentInclude.h"
    "agent::SecretAgent"
    SecretAgentAdaptor
)

add_library(
  agent-static
  STATIC
  ${AGENT_SOURCES}
)

target_link_libraries(
    agent-static
    notify_cpp
    util
    Qt5::Core
    Qt5::DBus
    ${LIBSECRET_LDFLAGS}
)

###########################
# Executables
###########################

add_executable(
  lomiri-indicator-network-secret-agent
  agent-main.cpp
)

target_link_libraries(
    lomiri-indicator-network-secret-agent
    agent-static
    Qt5::Core
    Qt5::DBus
)

###########################
# Installation
###########################

install(
  TARGETS
    lomiri-indicator-network-secret-agent
  RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri-indicator-network/"
)

=== doc/qt/cpp/examples/CMakeLists.txt ===

include_directories(${CMAKE_SOURCE_DIR}/src/connectivity-api/connectivity-qt)
add_executable(
  networking_status
  example_networking_status.cpp
)
target_link_libraries(networking_status ${CONNECTIVITY_QT_LIB_TARGET})

=== debian/changelog ===
lomiri-indicator-network (1.1.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Add 1004_ignore-SimPin2.patch. Fix SIM PIN entry e.g. on Lenovo Yoga X1
      (Mediatek T700 5G modem).
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 02 May 2025 17:02:44 +0200

=== debian/control ===
--- 
+++ 
@@ -35,7 +35,7 @@
                qttools5-dev-tools,
                valgrind-if-available,
                systemd-dev [linux-any],
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-indicator-network.git
 Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-indicator-network

## lomiri-indicator-network 1.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.13)
 
-project(lomiri-indicator-network VERSION 1.1.1 LANGUAGES C CXX)
+project(lomiri-indicator-network VERSION 1.1.2 LANGUAGES C CXX)
 
 string(TOLOWER "${CMAKE_BUILD_TYPE}" build_type_lower)
 
@@ -96,7 +96,7 @@
 set(COMMON_FLAGS "-Wall -Wextra -Wpedantic -fno-permissive -fPIC -fvisibility=hidden -pthread")
 
 set(CMAKE_C_STANDARD 11)
-set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD 17)
 if(CMAKE_COMPILER_IS_GNUCC)
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${COMMON_FLAGS}")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${COMMON_FLAGS}")

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 set(
   INDICATOR_DIR
-  "${CMAKE_INSTALL_DATADIR}/unity/indicators"
+  "${CMAKE_INSTALL_FULL_DATADIR}/unity/indicators"
   CACHE FILEPATH "Indicator directory"
 )
 
@@ -73,7 +73,7 @@
 ###########################
 
 # where to install
-set (XDG_AUTOSTART_DIR "${CMAKE_INSTALL_SYSCONFDIR}/xdg/autostart")
+set (XDG_AUTOSTART_DIR "${CMAKE_INSTALL_FULL_SYSCONFDIR}/xdg/autostart")
 message (STATUS "${XDG_AUTOSTART_DIR} is the DBus Service File install dir")
 
 set (XDG_AUTOSTART_NAME "${CMAKE_PROJECT_NAME}.desktop")

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-set(INSTALL_DOCDIR ${CMAKE_INSTALL_DOCDIR})
+set(INSTALL_DOCDIR ${CMAKE_INSTALL_FULL_DOCDIR})
 
 option(BUILD_DOC "Build documentation by default" TRUE)
 option(PRIVATE_DOCS "Build private documentation" FALSE)

=== po/CMakeLists.txt ===
--- 
+++ 
@@ -36,5 +36,5 @@
                    COPYONLY)
 endforeach(LANG)
 gettext_process_pot_file(${POT_FILE} ALL
-                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
+                         INSTALL_DESTINATION ${CMAKE_INSTALL_FULL_LOCALEDIR}
                          LANGUAGES ${LANGS})

=== scripts/CMakeLists.txt ===

file(GLOB_RECURSE SCRIPT_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/*.sh
)
add_custom_target(scriptfiles SOURCES ${SCRIPT_FILES})

=== src/CMakeLists.txt ===

add_subdirectory(connectivity-api)

add_subdirectory(agent)
add_subdirectory(indicator)
add_subdirectory(menumodel-cpp)
add_subdirectory(qdbus-stubs)
add_subdirectory(qrepowerd)
add_subdirectory(notify-cpp)
add_subdirectory(url-dispatcher-cpp)
add_subdirectory(util)

=== tests/CMakeLists.txt ===

find_package(GMock REQUIRED)
find_package(Qt5Test REQUIRED)

pkg_check_modules(TEST_DEPENDENCIES
  libqtdbustest-1 REQUIRED
  libqtdbusmock-1 REQUIRED
  libgmenuharness REQUIRED
)

include_directories(
  ${Qt5Test_INCLUDE_DIRS}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${GMOCK_INCLUDE_DIRS}
  ${GTEST_INCLUDE_DIRS}
  ${TEST_DEPENDENCIES_INCLUDE_DIRS}
)

add_definitions(
-DNETWORK_MANAGER_TEMPLATE_PATH="${CMAKE_CURRENT_SOURCE_DIR}/data/networkmanager.py"
)

add_subdirectory(integration)
add_subdirectory(unit)
add_subdirectory(utils)

=== doc/qt/CMakeLists.txt ===
add_subdirectory(cpp)
add_subdirectory(qml)

=== src/connectivity-api/CMakeLists.txt ===

#add_subdirectory(connectivity-cpp)
add_subdirectory(connectivity-qt)
add_subdirectory(connectivity-qml)
if(ENABLE_UBUNTU_COMPAT)
  add_subdirectory(connectivity-qml-ubuntu-compat)
endif()

=== src/dbus-cpp/CMakeLists.txt ===

set(DBUS_CPP_SERVICES
    services/connectivity.h
)

add_custom_target(DBusCppServicesHack SOURCES ${DBUS_CPP_SERVICES})

=== src/indicator/CMakeLists.txt ===

pkg_check_modules(
    QOFONO REQUIRED
    qofono-qt5
)
include_directories(${QOFONO_INCLUDE_DIRS})

include_directories("${CMAKE_SOURCE_DIR}/src")
include_directories("${CMAKE_BINARY_DIR}/src/qdbus-stubs")
include_directories("${CMAKE_SOURCE_DIR}/src/qdbus-stubs")

# list these here to have them visible in Qt Creator
file(
        GLOB_RECURSE NETWORK_SERVICE_HEADERS
        RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
        "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
)
add_custom_target(QtCreatorHeaderHack SOURCES ${NETWORK_SERVICE_HEADERS})

set(NETWORK_SERVICE_SOURCES
    ${NETWORK_SERVICE_HEADERS}

    nmofono/connectivity-service-settings.cpp
    nmofono/hotspot-manager.cpp
    nmofono/kill-switch.cpp
    nmofono/manager.cpp
    nmofono/manager-impl.cpp
    nmofono/connection/active-connection.cpp
    nmofono/connection/active-connection-manager.cpp
    nmofono/connection/active-vpn-connection.cpp
    nmofono/wifi/access-point.cpp
    nmofono/wifi/access-point-impl.cpp
    nmofono/wifi/grouped-access-point.cpp
    nmofono/wifi/wifi-link-impl.cpp
    nmofono/wwan/modem.cpp
    nmofono/wwan/sim.cpp
    nmofono/wwan/sim-manager.cpp
    nmofono/wwan/qofono-sim-wrapper.cpp
    nmofono/vpn/openvpn-connection.cpp
    nmofono/vpn/pptp-connection.cpp
    nmofono/vpn/vpn-connection.cpp
    nmofono/vpn/vpn-manager.cpp

    factory.cpp
    indicator-menu.cpp
    icons.cpp
    menu-builder.cpp
    sim-unlock-dialog.cpp
    root-state.cpp
    vpn-status-notifier.cpp
    sections/quick-access-section.cpp
    sections/wifi-section.cpp
    sections/vpn-section.cpp
    sections/wwan-section.cpp

    connectivity-service/connectivity-service.cpp
    connectivity-service/dbus-openvpn-connection.cpp
    connectivity-service/dbus-pptp-connection.cpp
    connectivity-service/dbus-vpn-connection.cpp
    connectivity-service/dbus-modem.cpp
    connectivity-service/dbus-sim.cpp

    menuitems/access-point-item.cpp
    menuitems/switch-item.cpp
    menuitems/text-item.cpp
    menuitems/vpn-item.cpp
    menuitems/wifi-link-item.cpp
    menuitems/wwan-link-item.cpp
    menuitems/modem-info-item.cpp
)

qt5_add_dbus_adaptor(
    NETWORK_SERVICE_SOURCES
    "${DATA_DIR}/com.lomiri.connectivity1.NetworkingStatus.xml"
    connectivity-service/connectivity-service.h
    connectivity_service::ConnectivityService
    NetworkingStatusAdaptor
)

qt5_add_dbus_adaptor(
    NETWORK_SERVICE_SOURCES
    "${DATA_DIR}/com.lomiri.connectivity1.Modem.xml"
    connectivity-service/dbus-modem.h
    connectivity_service::DBusModem
    ModemAdaptor
)

qt5_add_dbus_adaptor(
    NETWORK_SERVICE_SOURCES
    "${DATA_DIR}/com.lomiri.connectivity1.Sim.xml"
    connectivity-service/dbus-sim.h
    connectivity_service::DBusSim
    SimAdaptor
)

qt5_add_dbus_adaptor(
    NETWORK_SERVICE_SOURCES
    "${DATA_DIR}/com.lomiri.connectivity1.Private.xml"
    connectivity-service/connectivity-service.h
    connectivity_service::PrivateService
    NetworkingStatusPrivateAdaptor
)

qt5_add_dbus_adaptor(
    NETWORK_SERVICE_SOURCES
    "${DATA_DIR}/com.lomiri.connectivity1.vpn.VpnConnection.xml"
    connectivity-service/dbus-vpn-connection.h
    connectivity_service::DBusVpnConnection
    VpnConnectionAdaptor
)

qt5_add_dbus_adaptor(
    NETWORK_SERVICE_SOURCES
    "${DATA_DIR}/com.lomiri.connectivity1.vpn.VpnConnection.OpenVpn.xml"
    connectivity-service/dbus-openvpn-connection.h
    connectivity_service::DBusOpenvpnConnection
    OpenVpnAdaptor
)

qt5_add_dbus_adaptor(
    NETWORK_SERVICE_SOURCES
    "${DATA_DIR}/com.lomiri.connectivity1.vpn.VpnConnection.Pptp.xml"
    connectivity-service/dbus-pptp-connection.h
    connectivity_service::DBusPptpConnection
    PptpAdaptor
)

qt5_add_dbus_interface(
    NETWORK_SERVICE_SOURCES
    "${DATA_DIR}/org.freedesktop.DBus.Properties.xml"
    PropertiesInterface
)

add_library(
  lomiri-indicator-network-service-static
  STATIC
  ${NETWORK_SERVICE_SOURCES}
)

target_link_libraries(
    lomiri-indicator-network-service-static
    menumodel_cpp
    notify_cpp
    url_dispatcher_cpp
    qdbus-stubs
    qrepowerd
    util
    ${GLIB_LDFLAGS}
    ${QOFONO_LDFLAGS}
    Qt5::Core
    Qt5::DBus
)

###########################
# Executables
###########################

add_executable(
  lomiri-indicator-network-service
  main.cpp
)

target_link_libraries(
    lomiri-indicator-network-service
    lomiri-indicator-network-service-static
    Qt5::Core
    Qt5::DBus
)

###########################
# Installation
###########################

install(
  TARGETS
    lomiri-indicator-network-service
  RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri-indicator-network/"
)

=== src/menumodel-cpp/CMakeLists.txt ===

set(MENUMODEL_CPP_SOURCES
    gio-helpers/util.cpp
    gio-helpers/variant.h

    action.h
    action.cpp
    action-group.cpp
    action-group.h
    action-group-exporter.cpp
    action-group-exporter.h
    action-group-merger.cpp
    action-group-merger.h
    menu.cpp
    menu.h
    menu-exporter.h
    menu-item.h
    menu-item.cpp
    menu-merger.h
    menu-model.h
)

add_library(menumodel_cpp STATIC ${MENUMODEL_CPP_SOURCES})
target_link_libraries(
    menumodel_cpp
    ${GLIB_LIBRARIES}
)

=== debian/changelog ===
lomiri-indicator-network (1.1.2-1) unstable; urgency=medium

  * New upstream release.
    - Support building against GTest/GMock >= 1.17.0. (Closes: #1114189).
  * debian/control:
    + Add Multi-Arch: foreign declaration. Thanks, Multi-Arch Hinter.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 06 Sep 2025 11:37:14 +0200

=== debian/control ===
--- 
+++ 
@@ -118,6 +118,7 @@
 Package: lomiri-connectivity-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends},
          ${shlibs:Depends},
 Description: Lomiri Connectivity API - documentation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

NULL =

include /usr/share/dpkg/default.mk

#export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk

ENABLE_TESTS = ON
ifneq (,$(filter $(DEB_HOST_ARCH),arm64 s390x powerpc ppc64el))
        ENABLE_TESTS = OFF
endif

%:
	dh $@

override_dh_install:
	# drop upstart files
	rm -Rfv debian/tmp/usr/share/upstart/
	# empty directory
	rmdir debian/tmp/usr/share/doc/lomiri-indicator-network/qml/html/images/
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_TESTS=${ENABLE_TESTS} \
	                     $(NULL)

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
